
#prototype dfp-x.R1.gnls

library(MASS)

"puldet" <-
function(x, y, data=sys.parent(), baseline=list(nb=~x, rk=cubic(x)), start, type = c("dblexp", "user"), params=list(infrate="common", decrate="mixed", amplitude="mixed"), pulse.usr=list(shape, parlist, devlist, drop.var), weights = NULL, correlation = NULL, control=pul.control())
{

  .env <- environment()

"GenModel0" <- function(lp, form, parL) {
  # form : input basic pulse (two-sided) formula, not a function.
  # lp   : potential locations.
  # parL : parameters list as described in top calling function
  OLD.options <- options()
  on.exit(options(OLD.options))
  options(width=500,length=500)
  "Split" <- function(x,y) {
    ## where x : Character string to be split, y : character flag used to split x
    "CS" <- function(x, str) {
      ## CS, 'C'haracter 'S'plit, where x : char to be screened in 'str'
      FLAG <- 1
      jk <- character(0)
      while ( FLAG ) {
        w1 <- regexpr(x, str)
        Lw1 <- attr(w1, "match.length")
        if ( w1 != -1 ) {
          jk <- c(jk,substring(str, 1, w1))
          str <- substring(str, w1+Lw1, nchar(str))
          FLAG <- 1
          } else {
            jk <- c(jk, str)
            FLAG <- 0
            } }
      jk
      }
    # END CS(x,str)
    str1 <- x
    assign("CS", CS, env=.env)
    for ( i in 1:length(y) ) {
      j <- length(str1)
      tmp2 <- character(0)
      for ( k in 1:j) {
        tmp <- CS(y[i], str1[k])
        tmp2 <- c(tmp2,tmp)
        }
      str1 <- tmp2
      }
    str1
    } # END Split(x,y)
  assign("Split", Split, env=.env)
  pchar <- as.character(form)[3]
  seg <- Split(pchar, unlist(parL["p"], use.names=F) )
  modelfun <- character(0)
  for ( i in 1:length(lp) ) {
    OLDseg <- seg
    findP <-regexpr( unlist(parL["p"],use.names=F), seg)
    for ( j in 1:length(findP) ) {
      if ( findP[j] != -1 )
        seg[j] <- paste( substring(seg[j],1,findP[j]-attr(findP,"match.length")[j]),lp[i],sep="" )
      }
    MID.i.seg <- paste(seg, collapse="")
    modelfun <- paste(modelfun ,"+",MID.i.seg,sep="")
    # get rid of 1st symbol and wrap up formula
    if ( i == length(lp)) {
      modelfun <- substring(modelfun,2, nchar(modelfun))
      modelfun <- formula(paste( as.character(form)[2],modelfun, sep="~"))
      }
    seg <- OLDseg
    }
  return(modelfun)
}




"defx" <- function(y, x, params){
  if(params$decrate=="mixed" & params$amplitude=="mixed"){
     "def.1.derA" <- function(time,...) {
     		exp(a+A)*exp((time-P)*exp(l)*(time <= P))*(time <= P)+exp(a+A)*exp(-(time-P)*exp(r + R)*(time > P))*(time > P)
     }
     "def.1.dera" <- def.1.derA
     "def.1.derR" <- function(time,...) {
    		tmp <-  - (time - P) * exp(r+R)*(time>P)
    		exp(a+A)*exp(tmp)*tmp*(time>P)
     }
     "def.1.derr" <- function(time,...) {
    		tmp <-  - (time - P) * exp(r+R)*(time>P)
	      exp(a+A)*exp(tmp)*tmp*(time>P)
     }
    "def.1.derl" <- function(time,...) {
    		tmp <-  (time - P) * exp(l)*(time <= P)
	      exp(a+A)*exp(tmp)*tmp*(time <= P)
    }
##??? missing  assign("def.1.dera", def.1.dera, env=.env)  seems no use?
#    assign("def.1.derA", def.1.derA, env=.env)
#    assign("def.1.derR", def.1.derR, env=.env)
#    assign("def.1.derr", def.1.derr, env=.env)
#    assign("def.1.derl", def.1.derl, env=.env)
    pform <- as.formula(paste( y, "~ exp(a+A)*exp((", x, "-P)*exp(l)*(", x, "<= P))*(",
                            x, "<= P)+exp(a+A)*exp(-(", x,"-P)*exp(r + R)*(",x,"> P))*(",x,"> P)", sep=""))
    return(list(form = pform, parlist = list(random=c("A","R"), common=c("l",,"r", "a"), p="P"),
       der = list(def.1.derl, def.1.derr, def.1.dera, def.1.derA, def.1.derR)))
  }
  else if(params$decrate=="mixed")
  {    
    "def.1.dera" <- function(time,...) {
 	   exp(a)*exp((time-P)*exp(l)*(time <= P))*(time <= P)+exp(a)*exp(-(time-P)*exp(r + R)*(time > P))*(time > P)
    }
    "def.1.derR" <- function(time,...) {
  	  tmp <-  - (time - P) * exp(r+R)*(time>P)
    	  exp(a)*exp(tmp)*tmp*(time>P)
    }
   "def.1.derr" <- function(time,...) {
    	  tmp <-  - (time - P) * exp(r+R)*(time>P)
	  exp(a)*exp(tmp)*tmp*(time>P)
    }
   "def.1.derl" <- function(time,...) {
    	  tmp <-  (time - P) * exp(l)*(time <= P)
        exp(a)*exp(tmp)*tmp*(time <= P)
   }
#   assign("def.1.dera", def.1.dera, env=.env)
#   assign("def.1.derR", def.1.derR, env=.env)
#   assign("def.1.derr", def.1.derr, env=.env)
#   assign("def.1.derl", def.1.derl, env=.env)
   pform <- as.formula(paste( y, "~ exp(a)*exp((", x, "-P)*exp(l)*(", x, "<= P))*(",
                            x, "<= P)+exp(a)*exp(-(", x,"-P)*exp(r + R)*(",x,"> P))*(",x,"> P)", sep=""))
   if(params$amplitude=="common")
    return(list(form = pform, parlist = list(random=c("R"), common=c("l","r", "a"), p="P"),
       der = list(def.1.derl, def.1.derr, def.1.dera, def.1.derR)))
   else if(params$amplitude=="fixed")
    return(list(form = pform, parlist = list(random=c("R"), fixed=c("a"), common=c("l","r"), p="P"),
       der = list(def.1.derl, def.1.derr, def.1.derR, def.1.dera)))
   else 
    return(list(form = pform, parlist = list(random=c("a", "R"), common=c("l","r"), p="P"),
       der = list(def.1.derl, def.1.derr, def.1.dera, def.1.derR)))

  }
  else if(params$amplitude=="mixed")
  {
     "def.1.derA" <- function(time,...) {
     		exp(a+A)*exp((time-P)*exp(l)*(time <= P))*(time <= P)+exp(a+A)*exp(-(time-P)*exp(r)*(time > P))*(time > P)
     }
     "def.1.dera" <- def.1.derA
     "def.1.derr" <- function(time,...) {
    		tmp <-  - (time - P) * exp(r)*(time>P)
    		exp(a+A)*exp(tmp)*tmp*(time>P)
     }
    "def.1.derl" <- function(time,...) {
    		tmp <-  (time - P) * exp(l)*(time <= P)
	      exp(a+A)*exp(tmp)*tmp*(time <= P)
    }
#    assign("def.1.derA", def.1.derA, env=.env)
#    assign("def.1.dera", def.1.derR, env=.env)
#    assign("def.1.derr", def.1.derr, env=.env)
#    assign("def.1.derl", def.1.derl, env=.env)
    pform <- as.formula(paste( y, "~ exp(a+A)*exp((", x, "-P)*exp(l)*(", x, "<= P))*(",
                            x, "<= P)+exp(a+A)*exp(-(", x,"-P)*exp(r)*(",x,"> P))*(",x,"> P)", sep=""))
    if(params$decrate=="common")
     return(list(form = pform, parlist = list(random=c("A"), common=c("l","r", "a"), p="P"),
       der = list(def.1.derl, def.1.derr, def.1.dera, def.1.derA)))
    else
     return(list(form = pform, parlist = list(random=c("A"), fixed=c("r"), common=c("l", "a"), p="P"),
       der = list( def.1.derl, def.1.dera, def.1.derA, def.1.derr)))
  }
  else
  {
     "def.1.dera" <- function(time,...) {
    		exp(a)*exp((time-P)*exp(l)*(time <= P))*(time <= P)+exp(a)*exp(-(time-P)*exp(r)*(time > P))*(time > P)
    	}
     "def.1.derr" <- function(time,...) {
  		tmp <-  - (time - P) * exp(r)*(time>P)
 		   exp(a)*exp(tmp)*tmp*(time>P)
     }
     "def.1.derl" <- function(time,...) {
    		tmp <-  (time - P) * exp(l)*(time <= P)
    		   exp(a)*exp(tmp)*tmp*(time <= P)
     }
#     assign("def.1.dera", def.1.dera, env=.env)
#     assign("def.1.derr", def.1.derr, env=.env)
#     assign("def.1.derl", def.1.derl, env=.env)
     pform <- as.formula(paste( y, "~ exp(a)*exp((", x, "-P)*exp(l)*(", x, "<= P))*(", x, "<= P)+exp(a)*exp(-(", x,"-P)*exp(r)*(",x,"> P))*(",x,"> P)", sep=""))
     if(params$decrate=="common" & params$amplitude=="common")
       return(list(form = pform, parlist = list(common=c("l", "r", "a"), p="P"), der = list(def.1.derl, def.1.derr, def.1.dera)))
     else if(params$decrate=="common" & params$amplitude=="fixed")  
       return(list(form = pform, parlist = list(common=c("l", "r"), fixed=c("a"), p="P"), der = list(def.1.derl, def.1.derr, def.1.dera)))
     else if(params$decrate=="common" & params$amplitude=="random")  
       return(list(form = pform, parlist = list(common=c("l", "r"), random=c("a"), p="P"), der = list(def.1.derl, def.1.derr, def.1.dera)))
     else if(params$decrate=="fixed" & params$amplitude=="common")
       return(list(form = pform, parlist = list(common=c("l", "a"), fixed=c("r"), p="P"), der = list(def.1.derl, def.1.dera, def.1.derr)))
     else if(params$decrate=="fixed" & params$amplitude=="fixed")
       return(list(form = pform, parlist = list(common=c("l"), fixed=c("r", "a"), p="P"), der = list(def.1.derl, def.1.derr, def.1.dera))) 
     else if(params$decrate=="fixed" & params$amplitude=="random")
       return(list(form = pform, parlist = list(common=c("l"), fixed=c("r"), random=c("a"), p="P"), der = list(def.1.derl, def.1.dera, def.1.derr))) 
   }
}  



posterior.ranef.info <-  function(nlmefit, ssrfit, baseline, LP, x, devlist, pList, Sigma2, level = 0.05)
{
# a special function calculating posterior statisitcs for nonlinear mixed effects
# hence it applies to special form of covariance matrix, not used arbitrarily
# Refer to the paper "That BLUP is a good thing" and Yuedong's mixed SSANOVA paper
	pList.old <- pList
        pList <- list(fixed=pList$common, random=as.list(c(pList$random, pList$fixed)), p=pList$p)
        Z <- numeric(0)    
        for(k in 1:length(pList$fixed)) {
                assign(pList$fixed[k], nlmefit$NextFixed[k], env=.env)
        }
        if(length(pList$random) != 0)
	{ 
           Block <- vector("list", length(unlist(pList$random)))
           for(i in 1:length(unlist(pList$random))) {
                Block[[i]] <- numeric(0)
            }

           ABP <- cbind(matrix(c(nlmefit$ranEst, nlmefit$NextFixed[-c(1:length(pList$fixed))]), nrow = length(nlmefit$P)), nlmefit$P)
           dimnames(ABP)[[2]] <- unlist(c(pList$random, pList$p), use.names = F)

### Initial values for fixed effectc matrix X
           for(i in 1:length(LP)) {
                for(j in 1:length(pList$random)) {
                        assign(pList$random[[j]], ABP[i, j], env=.env)
                }
                assign(pList$p, ABP[i, pList$p], env=.env)

                for(j in 1:length(unlist(pList$random))) {
                        Block[[j]] <- cbind(Block[[j]], apply(as.matrix(x), 1,
                                devlist[[j+length(pList$fixed)]]))
                }
                if(i == length(LP)) {
                        Z <- numeric(0)
                        for(k in 1:length(Block))
                                Z <- cbind(Z, Block[[k]])
                }
           }
        } 
        X <- matrix(rep(0, length(x)*length(pList$fixed)), nrow=length(x))    
        for(i in 1:length(LP)) {
                 assign(pList$p, LP[i], env=.env)
####The following loop is for derivatives of fixed effects
                XX <- NULL
                for(j in 1:length(pList$fixed)) {
                        XX <- cbind(XX, apply(as.matrix(x), 1,
                                devlist[[j]]))
                }

                X <- X+XX
         }
        
        if(length(pList.old$random)==0) 
		{ X <- cbind(X, Z)
                  Z <- numeric(0)
            }
	 else
	      { X <- cbind(X, Z[,-c(1:(length(pList.old$random)*length(LP)))])
       	        Z <- Z[,c(1:(length(pList.old$random)*length(LP)))]
        	 } 
  # calculate the posterior; script implies at least one random effects
        ransd <- nlmefit$ranSdDev
        diaG <- G <- numeric(0)
        W.inv  <- diag(rep(1,length(x)))
        if(length(ransd) != 0 )
        {
           for(i in 1:length(ransd)) {
                diaG <- c(diaG, rep(ransd[i]^2, length(LP)))
           }
         
#        Dq <- diag(diaG)/(nlmefit$info["SdDev"])^2
#        Zhat <- rbind(Z, chol(ginv(Dq)))    # symbols as used in NLME papers

         G <- diag(sqrt(diaG)/nlmefit$info["SdDev"])
         W.inv <- Z%*%G%*%t(Z)+ W.inv
        }
	if(is.null(baseline)) 
	  {
		Tmat <- X
		B <- W.inv
	  }
	  else
	  { 
	  Tmat <- cbind(ssrfit$ssrObj$s, X)
          nlambda <- 10^ssrfit$ssrObj$rkpk.obj$nlaht
          B <- ssrfit$ssrObj$q[[1]]/nlambda + W.inv
	  }

        qr.result <- qr(Tmat)
        qrq <- qr.Q(qr.result, complete = T)
        qrq2 <- qrq[, (ncol(Tmat) + 1):length(x)]
        qrq1 <- qrq[, 1:ncol(Tmat)]
        qrr <- qr.R(qr.result)
        qrr.inv <- solve(qrr)
        
        H <- qrq2 %*% ginv(t(qrq2)%*%B%*%qrq2) %*% t(qrq2)
        
        ginvB <- ginv(B)
        fixVar <-  Sigma2*qrr.inv%*%ginv(t(qrq1)%*%ginvB%*%qrq1)%*%t(qrr.inv)
        if(is.null(baseline)) Varmat <- fixVar
        else
        Varmat <- fixVar[-c(1:ncol(ssrfit$ssrObj$s)),-c(1:ncol(ssrfit$ssrObj$s))]
        obj <- NULL

        if(length(pList.old$random) != 0)
        {
          I2 <- diag(rep(1, length(diaG)))
          ranVar <-  Sigma2 * G %*% (I2-t(Z)%*%H%*%Z%*%G)
          fixranCov <- - fixVar %*% t(Tmat) %*% ginvB %*% Z %*% G
          if(is.null(baseline)) Varmat <- rbind(cbind(fixVar, fixranCov), cbind(t(fixranCov), ranVar))
          else
          Varmat <- rbind(cbind(fixVar[,-c(1:ncol(ssrfit$ssrObj$s))], fixranCov)[-c(1:ncol(ssrfit$ssrObj$s)),], cbind(t(fixranCov[-c(1:ncol(ssrfit$ssrObj$s)),]), ranVar))        
        
          tbl <- cbind(c(nlmefit$ranEst, nlmefit$NextFixed[-c(1:length(pList$fixed))]), diag(Varmat)[-c(1:length(pList$fixed))])
          assign("level", level, env=.env)
          obj <- t(apply(tbl, 1, FUN = function(x, Level = level)
          {
                tstat <- x[1]/sqrt(x[2])
                pvalue <- 2 * (1 - pnorm(tstat))
                ind <- ifelse(pvalue < Level, 1, 0)
                ubd <- x[1] + qnorm(1 - level/2) * sqrt(x[2])
                lbd <- x[1] - qnorm(1 - level/2) * sqrt(x[2])
                c(tstat, pvalue, lbd, ubd, ind)
          }
          ))
          dimnames(obj)[[2]] <- c("t-value", "p-value", "lower-bdd", "upper-bdd",
                "significant")
        }        
        return(list(obj=obj, Var= Varmat))
} #


"GNLScallx" <- function(tmp, Fixed, P, pulse, parList, gnls.control, corr, weight )
{
# tmp is a data.frame with the same name of data
# pulse : input basic pulse formula, not a function. e.g. conc ~ exp(time)
# Fixed   : initial used to fit NLME
# parList : list of (par, fixed, pos) of parameters.
  assign("tmp", tmp, env=.env)
  assign("P", P, env=.env)	
  n <- length(P)
  Fixfor <- as.formula(paste(paste(parList$common, collapse = "+"), "~1",sep = ""))
  if(is.null(parList$fixed))
  { 
	  modfor <- GenModel0(P, pulse, parList)
	  fit <- try(gnls(modfor, data = tmp, params=list(Fixfor), start=c(Fixed), control=gnls.control, correlation=corr, weights=weight) )
  }
  else
  {
	ranpar <- as.list(unlist(parList$fixed, use.names = F))
	RanList <- lapply(ranpar, FUN = function(x, k)
                    {
                      Rd <- paste(x, 1:k, "+", sep = "", collapse = "")
                }
                    , n)	# wrapup fixed, random and model formula used in NLME
 	temp <- paste(RanList, collapse = "")
	Ranfor <- as.formula(paste(substring(temp, 1, nchar(temp)-1), "~1",sep = ""))
  	modfor <- GenModel(P, pulse, list(common=parList$common, random=as.list(parList$fixed), p=parList$p))
  	fit <- try(gnls(modfor, data = tmp, params=list(Fixfor, Ranfor), start=c(Fixed), control=gnls.control, correlation=corr, weights=weight)) 
  }
if(is.element("gnls", class(fit)))
  { 
  fixed.est <- fit$coef
  invisible(list(fit = as.vector(fit$fitted), P = P,
                 info = c(LogLik = logLik(fit), AICV = AIC(fit), BICV = BIC(fit),
                   SdDev = fit$sigma), NextFixed=fixed.est, gnlsObj = fit))
}
###########deal with problem of breakdown of gnls###########
  else
  return(NA)
#############################################################
}
"SSRcall" <- function(y, s, form, Updata, rk, op = "v", corr, weight, limnla)
{
  # Updata should be scaled beforehand
  assign("rk", rk, env=.env)
#  rk <- eval(rk, envir=Updata)
  fit.dsidr <- dsidr(y=y, s=s, q=rk, vmu=op, limnla=limnla)
#  fit <- ssr(as.formula(form), data = Updata, rk = rk, method = op,  correlation =corr, weight=weight, limnla=limnla)
##########################
Call <- quote(ssr(formula = as.formula(form),  data = Updata, rk = list(rk), spar = op, correlation =corr, weight=weight, limnla=limnla))

fit <- list(call = Call, expand.call = Call, data = Updata, 
        y = y, weight = weight, fit = as.vector(fit.dsidr$fit), 
        s = s, q = list(rk), lambda = 10^fit.dsidr$nlaht/dim(data)[1], residuals = as.vector(fit.dsidr$resi), 
        sigma = sqrt(fit.dsidr$varht), family = "gaussian", coef = list(c = fit.dsidr$c, 
            d = fit.dsidr$d), df = fit.dsidr$df, rkpk.obj = fit.dsidr, 
        scale = FALSE, cor.est = NULL, var.est = NULL, 
        control = ssr.control())
   
    class(fit) <- "ssr"
    fit$call[[1]] <- as.name("ssr")
   
    fit$lme.obj <- NULL
################################

  invisible(list(fit = fit$fit, gcvS = fit$rkpk.obj$score, nlaht = fit$rkpk.obj$nlaht,
                 score = fit$rkpk.obj$vmu, ssrObj = fit))
  }



"NLMEcallx" <- function(tmp, Fixed, P, pulse, parList, nlme.control, corr, weight )
{
# tmp is a data.frame with the same name of data
# pulse : input basic pulse formula, not a function. e.g. conc ~ exp(time)
# Fixed   : initial used to fit NLME
# parList : list of (par, fixed, pos) of parameters.
  assign("tmp", tmp, env=.env)
  assign("P", P, env=.env)	# prepare for construction of random effects
  n <- length(P)
  ranpar <- as.list(parList$random)
  RanList <- lapply(ranpar, FUN = function(x, k)
                    {
                      Rd <- paste(x, 1:k, "+", sep = "", collapse = "")
                      pdIdent(formula(paste(substring(Rd, 1, nchar(Rd) - 1), "~", 1,collapse = "")))
                      }
                    , n)
  fixpar <- as.list(parList$fixed)
  FixList <- lapply(fixpar, FUN = function(x, k)
                    {
                      Rd <- paste(x, 1:k, "+", sep = "", collapse = "")
                    }
                    , n)	
  temp <- paste( paste(parList$common, collapse = "+"), paste(FixList, collapse = ""), sep="+")
  Fixfor <- as.formula(paste(substring(temp, 1, nchar(temp)-1), "~1",sep = ""))
  if(length(ranpar) > 1)
  Ranfor <- pdBlocked(RanList)
  else Ranfor <- RanList[[1]]	
# external GenModel()
  modfor <- GenModel(P, pulse, list(common=parList$common, random=list(parList$random, parList$fixed), p=parList$p))
###########################################################
  group <- rep(1, dim(tmp)[1])
  fit <- try(nlme(modfor, data = data.frame(tmp, group), fixed = Fixfor, random = list(group=Ranfor), control = nlme.control,
              start = Fixed, method = "REML", correlation = corr, weights = weight))
if(is.element("nlme", class(fit)))
  { 
  ranEst <- fit$coef$random$group[1,]
  ranSd <- exp(as.vector(coef(fit$modelStruct, T))) * fit$sigma
  invisible(list(fit = as.vector(fit$fitted[, 2]), ranEst = ranEst, P = P,
                 info = c(LogLik = logLik(fit), AICV = AIC(fit), BICV = BIC(fit),
                   SdDev = fit$sigma), ranSdDev = ranSd,
                 NextFixed = fit$coef$fixed, nlmeObj = fit))
}
###########deal with problem of breakdown of nlme###########
  else
  return(NA)
#############################################################
}


"GenModel" <- function(lp, form, parL) {
  # form : input basic pulse (two-sided) formula, not a function.
  # lp   : potential locations.
  # parL : parameters list as described in top calling function
  OLD.options <- options()
  on.exit(options(OLD.options))
  options(width=500,length=500)
  "Split" <- function(x,y) {
    ## where x : Character string to be split, y : character flag used to split x
    "CS" <- function(x, str) {
      ## CS, 'C'haracter 'S'plit, where x : char to be screened in 'str'
      FLAG <- 1
      jk <- character(0)
      while ( FLAG ) {
        w1 <- regexpr(x, str)
        Lw1 <- attr(w1, "match.length")
        if ( w1 != -1 ) {
          jk <- c(jk,substring(str, 1, w1))
          str <- substring(str, w1+Lw1, nchar(str))
          FLAG <- 1
          } else {
            jk <- c(jk, str)
            FLAG <- 0
            } }
      jk
      }
    # END CS(x,str)
    str1 <- x
    assign("CS", CS, env=.env)
    for ( i in 1:length(y) ) {
      j <- length(str1)
      tmp2 <- character(0)
      for ( k in 1:j) {
        tmp <- CS(y[i], str1[k])
        tmp2 <- c(tmp2,tmp)
        }
      str1 <- tmp2
      }
    str1
    } # END Split(x,y)
  assign("Split", Split, env=.env)
  pchar <- as.character(form)[3]
  seg <- Split(pchar, unlist(parL[c("random","p")], use.names=F) )
  # above split wrt all parameters except 'fixed'
  modelfun <- character(0)
  for ( i in 1:length(lp) ) {
    OLDseg <- seg
    findP <-regexpr( unlist(parL["p"],use.names=F), seg)
    for ( j in 1:length(findP) ) {
      if ( findP[j] != -1 )
        seg[j] <- paste( substring(seg[j],1,findP[j]-attr(findP,"match.length")[j]),lp[i],sep="" )
      }
    MID.i.seg <- paste(seg, collapse="")
    seg <- Split(MID.i.seg, unlist(parL$random, use.names=F))
    jk <- paste(seg,i, sep="")
    jk[length(seg)] <- ifelse(i<10,
                              substring( jk[length(seg)],1, nchar(jk[length(seg)])-1),
                              substring( jk[length(seg)],1, nchar(jk[length(seg)])-2))
    # self-adding
    jk <- paste(jk,collapse="")
    modelfun <- paste(modelfun ,"+",jk ,sep="")
    # get rid of 1st symbol and wrap up formula
    if ( i == length(lp)) {
      modelfun <- substring(modelfun,2, nchar(modelfun))
      modelfun <- formula(paste( as.character(form)[2],modelfun, sep="~"))
      }
    seg <- OLDseg
    }
  return(modelfun)
}
#debug(NLMEcallx)
#debug(GNLScallx)
#debug(posterior.ranef.info)
  
  xcall <- match.call()
  assign("xcall", xcall, env=.env)
  ###????get names of x and y
  res <- deparse(xcall$y)
  ind <- deparse(xcall$x)
  data.orig <- data
  x <- eval(xcall$x, data.orig)
  y <- eval(xcall$y, data.orig) 
      
  data <- data.frame(x, y)
  dimnames(data)[[2]] <- c(ind, res)
if(is.element("baseline", names(xcall)))
    if(!is.element("list", all.names(xcall$baseline)))
         {baseline <- eval(xcall$baseline, sys.parent())
          if(!is.list(baseline))
             {if(is.numeric(baseline))
               {if(length(baseline) > 0)
                 {if(baseline==0) baseline <- 0
                 else 
                 stop("wrong format of baseline input")
                 }
               else
                 stop("wrong format of baseline input")
               }
             else
               stop("wrong format of baseline input")
           }
           else {varName <- unique(all.vars(baseline$nb))
                  if(varName==res) stop("response appear on the rhs")}

         }
 if(is.null(xcall$baseline)) {
      baseline <- quote(list(nb=~x, rk=cubic(x)))
      varName <- "x"
     }
      else if(xcall$baseline==0) baseline <- NULL
      else if(is.element("list", all.names(xcall$baseline))) 
{baseline <- xcall$baseline
varName <- unique(all.vars(baseline$rk))
 if(varName==res) stop("response appear on the rhs")}
  if(missing(type))
    stop("type must be sepecified, eihter \"dblexp\" or \"user\"")
  type <- match.arg(type)
  tmp <- tmp0 <- data
  nlme <- TRUE
  if(type == "dblexp")
    {
     if(missing(params)) stop("params must be specified when type is dblexp")
     if(params$infrate!="common") stop("infussion rate can only be of type common")
     if(!is.element(params$decrate, c("common", "mixed", "fixed"))) stop("decay rate can only be one of the following types: common, fixed, and mixed")
     if(!is.element(params$amplitude, c("common", "mixed", "fixed", "random"))) stop("amplitude can only be one of the following types: common, fixed, mixed, and random") 
     parList <- defx(res, ind, params)$parlist
     devList <- defx(res, ind, params)$der
     pulseForm <- defx(res, ind, params)$form
     if(params$amplitude=="common") stop("drop variable can not be of type common")
     drop.var <- c("a", "A")
     if(params$decrate != "mixed" & params$amplitude != "mixed" & params$amplitude != "random") nlme <- FALSE
    } 
 else
    {
      if(missing(pulse.usr$shape) | missing(pulse.usr$parlist) | missing(pulse.usr$devlist))
        stop("shape, parlist, and devlist should be provided when type is \"user\"")
      if(!((class(pulse.usr$shape) == "formula") & (length(pulse.usr$shape) == 3)))
        stop("shape should be two-sided formula")
      if(!(is.list(pulse.usr$devlist) & is.list(pulse.usr$parlist)))
        stop("parlist and devlist should be lists.")
      # figure out fixed effects parameters
      ##xx <-  parameter.names(pulse.usr$shape, data)
      ##yy <-  unlist(pulse.usr$params, use.names=F)
      ##pulse.usr$params$fixed <- xx[ match(xx,yy) == "NA" ]
      parList <- pulse.usr$parlist
      devList <- pulse.usr$devlist
      pulseForm <- pulse.usr$shape
      drop.var <- pulse.usr$drop.var
      if(is.element(drop.var, parList$common)) stop("drop variable can not be of type common")
      }
  ctr <- pul.control()
  if(!missing(control)) {
   if(!all(is.element(names(control), c("nlme", "ssr", "gnls", "pul"))))
       stop("control must be a list with names nlme, ssr, gnls or pul")
       if(!is.null(control$nlme))
      ctr$nlme[names(control$nlme)] <- control$nlme
    if(!is.null(control$ssr))
      ctr$ssr[names(control$ssr)] <- control$ssr
    if(!is.null(control$gnls))
       ctr$gnls[names(control$gnls)] <- control$gnls
    if(!is.null(control$pul))
      ctr$pul[names(control$pul)] <- control$pul
    }
  p.old <- p <- start$puloc
  t.flag <- length(p) == start$kmin   
  baseEst <- start$Inif
  idx <- length(p)
  listEst <- listStat <- vector("list", idx - start$kmin + 1)
  nobs <- length(tmp0[, 2])
  names(p.old) <- paste("x", 1:length(p.old), sep = "")
  if(ctr$pul$trace)
  {  cat("\nBegin with original selection of features ...\n")
     print(p.old)
  }
  GO1 <- 1
  Initial <- start$fixed
  select.tbl.name <- c("NP","BIC","RIC","AIC","GCV","DF","df(base)","nlaht","N","RSS","Sigma2", "DROP")
  select.tbl <- matrix(vector(mode = "numeric", length = length(select.tbl.name)), nrow=1)
  TOLr <- ctr$pul$TOLr	# for relative precison of GCVs
  NLMEdf <- NULL
 # main iteration
  while(GO1) {
    GCVs <- numeric(0)
    RelPrecision <- GO2 <- 1
    Flag1 <- FALSE	# skip RelPrecision at 1st time
    tmp[, res] <- tmp0[, res] - baseEst
    i.go2 <- 0
    while(GO2) {
      if(nlme)
        NLMEfit <- NLMEcallx(tmp, Initial, p, pulseForm, parList, ctr$nlme, corr = correlation, weight = weights)
      else
        NLMEfit <- GNLScallx(tmp, Initial, p, pulseForm, parList, ctr$nlme, corr = correlation, weight = weights)
 ###########deal with problem of breakdown of nlme###########
      if(any(is.na(NLMEfit))) break
      else
      {
############################################################
      
      tmp[, res] <- tmp0[, res] - NLMEfit$fit
      tmp[,ind] <- xscale( tmp[, ind] )
      if ( is.null(weights) && is.null(correlation) )
        s.wt <- NULL else {
          if ( !is.null(weights) ) {
            varSt <- varWeights(NLMEfit$nlmeObj$modelStruct$varStruct)
            if ( is.null(correlation) )
              s.wt <- (1/varSt)^2
            else {
              corSt <- corMatrix(NLMEfit$nlmeObj$modelStruct$corStruct)
              s.wt <- (1/varSt)^2 %*% corSt
              }
            } else {
              s.wt <- corMatrix(NLMEfit$nlmeObj$modelStruct$corStruct)
              }
          }
     
      if(is.null(baseline)) 
         {
 	   SSRfit <- list(fit=0, ssrObj=list(rkpk.obj=list(df=0, nlaht=NA)), gcvS=GCVs)
	   RelPrecision <- 0
	   }
	else {
###???      form <- paste(res, deparse(xcall$baseline$nb))
         form <- paste(deparse(xcall$y), deparse(baseline$nb[[2]]), sep="~")
            I <- rep(1, dim(tmp)[1])
         if(length(varName) == 0) 
            {s <- matrix(I, ncol=1)
             rk <- baseline$rk}
         else
            {tt <- xscale(eval(as.name(varName), env=data.orig))
             rk.data <- data.frame(I, tt)
             dimnames(rk.data)[[2]] <- c("I", varName)
             if(length(all.vars(baseline$nb))==0) s <- matrix(I, ncol=1)
             else   
                s <- model.matrix(as.formula(paste("I", deparse(baseline$nb[[2]]), sep="~")), data=rk.data)
             rk <- eval(baseline$rk, env=rk.data)
            }
         SSRfit <- SSRcall(tmp[, res], s=s, form, Updata = tmp, rk= rk, op = ctr$ssr$spar,
                        weight = s.wt, corr = NULL, limnla=ctr$ssr$limnla)
      }
#varName <- unique(all.vars(baseline$nb))
#         tt <- xscale(eval(as.name(varName), env=data.orig))
#         Updata <- data.frame(tmp, tt)
#         dimnames(Updata)[[2]] <- c(dimnames(tmp)[[2]], varName)
#         SSRfit <- SSRcall(Updata[, res], form, Updata = Updata, rk= baseline$rk, op = ctr$ssr$spar,
#                        weight = s.wt, corr = NULL, limnla=ctr$ssr$limnla)
#      }
      tmp[,ind] <- tmp0[, ind]
      if(Flag1) {
        RelPrecision <- abs(GCVs - SSRfit$gcvS)/GCVs
        }
      GO2 <- ifelse(RelPrecision >= TOLr, 1, 0)
      if ( is.null(s.wt) ) {
        RSS <- sum((tmp0[, res] - (NLMEfit$fit + SSRfit$fit))^2) }
      else {
        RSS <- (tmp0[, res] - (NLMEfit$fit + SSRfit$fit)) %*% solve(s.wt) %*% (tmp0[, res] - (NLMEfit$fit + SSRfit$fit))
     }
      NLMEdf <- (2 * NLMEfit$info["LogLik"] + NLMEfit$info["AICV"])/2
      IDF <- ctr$pul$IDF
      if(idx == length(start$puloc)) {
        SIGMA2 <- RSS/(nobs - NLMEdf - SSRfit$ssrObj$rkpk.obj$df)
 ###??? definition of df (in the paper and here for different situations)
       df.T <- SSRfit$ssrObj$rkpk.obj$df + IDF*(length(unlist(parList$random))*length(p)+length(parList$fixed)+length(parList$common))
        }
      Sigma2 <- RSS/(nobs - NLMEdf - SSRfit$ssrObj$rkpk.obj$df)
      df.t <- SSRfit$ssrObj$rkpk.obj$df + IDF*(length(unlist(parList$random))*length(p)+length(parList$fixed)+length(parList$common))
      bic <- RSS + SIGMA2*log(nobs)*( df.t )
      ric <- RSS + SIGMA2*2*log(df.T)*df.t
      aic <- RSS + SIGMA2*2*df.t
      gcv <- RSS / (1-df.t/nobs)^2
      ModelSelect <- c(length(p), bic, ric, aic, gcv, df.t, SSRfit$ssrObj$rkpk.obj$df, 
                       SSRfit$ssrObj$rkpk.obj$nlaht, nobs, RSS, Sigma2, 0)
      names(ModelSelect) <- select.tbl.name

      GCVs <- SSRfit$gcvS
      BaseLine <- SSRfit$fit
      tmp[, res] <- tmp0[, res] - BaseLine
#      ApInitial <- NLMEfit$NextFixed
      Flag1 <- TRUE
      i.go2 <- i.go2 + 1
      }
}
###########deal with problem of breakdown of nlme###########
    if(any(is.na(NLMEfit))) break
    else{
###########################################################
      postr.info <- posterior.ranef.info(NLMEfit, SSRfit, baseline, p, tmp0[, ind], devList, parList, Sigma2, level = 0.05)
     Varmat <- postr.info$Var
     varnames <- c(names(NLMEfit$NextFixed), names(NLMEfit$ranEst))
#print(dim(Varmat))
#print(varnames)
     dimnames(Varmat) <- list(varnames, varnames)
     listEst[[idx]] <- list(coef = list(fixed=NLMEfit$NextFixed, ranEst = NLMEfit$ranEst), Var=Varmat,
                           baseFitted = SSRfit$fit, nlmeFitted = NLMEfit$fit, nlmeObj = NLMEfit$nlmeObj, gnlsObj=NLMEfit$gnlsObj, ssrObj = SSRfit$ssrObj, callxObj=NLMEfit)
    tstats <- postr.info$obj
    droprow1 <- (1:dim(tstats)[1])[is.element(dimnames(tstats)[[1]], paste(drop.var, 1, sep=""))] 
#    sapply(dimnames(tstats)[[1]], function(x, drop.var)
#                     {tmp <- strsplit(x, split="")[[1]]
#                      return((length(tmp)==2 & length(intersect(tmp, drop.var)) != 0))}, drop.var=drop.var) 
    listStat[[idx]] <- tmp1 <- cbind(p, postr.info$obj[droprow1:(droprow1+length(p)-1),])
    ModelSelect["DROP"] <- (1:length(start$puloc))[is.element(start$puloc,tmp1[tmp1[, "t-value"] == min(tmp1[,"t-value"]), "p"])]
    select.tbl <- rbind(select.tbl, ModelSelect)
    Q.print <- (!as.logical(GO2) && Flag1)
    if(Q.print & ctr$pul$trace) {
        cat(paste("\niterations : ", i.go2, "times", "\n"))
        cat(paste("relative precision", signif(RelPrecision, 6), "(", "<", TOLr, ")", "\n"))
    }

   if(idx <= start$kmin) {
      GO1 <- 0
      tmp2 <- tmp1
      temp.p <- tmp2[, 1]	
     # if (Q.print) print(ModelSelect)
      }
    else {
      GO1 <- 1	# delete one at a time
      tmp2 <- tmp1[tmp1[, 2] != min(tmp1[, 2]),  ]
      temp.p <- numeric(0)
      for(i in 1:length(tmp2[, 1]))
        temp.p <- c(temp.p, p.old[p.old == (tmp2[, 1])[i]])
     # if (Q.print) {
     #   print(ModelSelect)
     #   cat(paste("\ncurrent  locations :\n"))
     #   print(temp.p)
     #   } # end of print
      }
    if (Q.print & ctr$pul$trace) {
        print(ModelSelect)
        if ( idx > start$k ) {
          cat(paste("\ncurrent  locations :\n"))
          print(temp.p)
        }
      }
    p <- tmp2[, 1]
    idx <- idx - 1
    if(length(parList$fixed) > 0)
      {
       tmp.drop.loc <- (1:dim(tmp1)[1])[tmp1[, 2] == min(tmp1[, 2])]
       Initial <- Initial[-c(length(parList$common)+(1:length(parList$fixed))*tmp.drop.loc)]
      }
    }}   # END while (GO1)
############For breakdown of the first iteration###########
  if(nrow(select.tbl) > 1)
  {
############################################################
  select.tbl <- as.data.frame(select.tbl[-1,  ])
  dimnames(select.tbl)[[1]] <- 1:(dim(select.tbl)[1])
  if(t.flag | (ncol(select.tbl) ==1)) {
        dimnames(select.tbl)[[1]] <- select.tbl.name
        select.tbl <- as.data.frame(t(select.tbl))
        dimnames(select.tbl)[[1]] <- 1  
  }
  if(ctr$pul$trace)
  {  cat("\nSummary of statistics:\n")
     if ( t.flag) {
        print(select.tbl)
      }
      else 
         print(as.data.frame(select.tbl[,-1], row.names=as.character(select.tbl[,"NP"])))
  }
######ncol(select.tbl) ==1 deals with situation that only one GO1 iteration is finished normally#########
  
  k.AIC <- min(select.tbl[select.tbl[, "AIC"] == min( select.tbl[, "AIC"] ), "NP"])
  AIC.drop <- select.tbl[select.tbl[, "NP"] > k.AIC, "DROP"]
  if(length(AIC.drop) > 0)
     AIC.loc <- start$puloc[-AIC.drop]
  else
     AIC.loc <- start$puloc
  fAIC.est <- listEst[[k.AIC]]$baseFitted
  nlmeAIC.est <- listEst[[k.AIC]]$nlmeFitted
  coef.AIC <- listEst[[k.AIC]]$coef
 
 k.RIC <- min(select.tbl[select.tbl[, "RIC"] == min( select.tbl[, "RIC"] ), "NP"])
  RIC.drop <- select.tbl[select.tbl[, "NP"] > k.RIC, "DROP"]
  if(length(RIC.drop) > 0)
     RIC.loc <- start$puloc[-RIC.drop]
  else
     RIC.loc <- start$puloc
  fRIC.est <- listEst[[k.RIC]]$baseFitted
  nlmeRIC.est <- listEst[[k.RIC]]$nlmeFitted
  coef.RIC <- listEst[[k.RIC]]$coef
 
 k.BIC <- min(select.tbl[select.tbl[, "BIC"] == min( select.tbl[, "BIC"] ), "NP"])
  BIC.drop <- select.tbl[select.tbl[, "NP"] > k.BIC, "DROP"]
  if(length(BIC.drop) > 0)
     BIC.loc <- start$puloc[-BIC.drop]
  else
     BIC.loc <- start$puloc
  fBIC.est <- listEst[[k.BIC]]$baseFitted
  nlmeBIC.est <- listEst[[k.BIC]]$nlmeFitted
  coef.BIC <- listEst[[k.BIC]]$coef

 k.GCV <- min(select.tbl[select.tbl[, "GCV"] == min( select.tbl[, "GCV"] ), "NP"])
  GCV.drop <- select.tbl[select.tbl[, "NP"] > k.GCV, "DROP"]
  if(length(GCV.drop) > 0)
     GCV.loc <- start$puloc[-GCV.drop]
  else
     GCV.loc <- start$puloc
  fGCV.est <- listEst[[k.GCV]]$baseFitted
  nlmeGCV.est <- listEst[[k.GCV]]$nlmeFitted
  coef.GCV <- listEst[[k.GCV]]$coef

  obj <- list(tbl = select.tbl, est = listEst, stat = listStat, detloc=list(AIC=list(pulnum=k.AIC, puloc=AIC.loc, coef=coef.AIC, baseline=fAIC.est, nlmefit =nlmeAIC.est), GCV=list(pulnum=k.GCV, puloc=GCV.loc, coef=coef.GCV, baseline=fGCV.est, nlmefit =nlmeGCV.est),BIC=list(pulnum=k.BIC, puloc=BIC.loc, coef=coef.BIC, baseline=fBIC.est, nlmefit =nlmeBIC.est),RIC=list(pulnum=k.RIC, puloc=RIC.loc, coef=coef.RIC, baseline=fRIC.est, nlmefit =nlmeRIC.est)))
  obj$call <- xcall
  class(obj) <- "puldet"
  invisible(obj)
}}
#

"print.puldet" <- function(x)
{
  cat("Pulses Detection with Semiparametric Model\n")
  cat("Call:\n")
  dput(x$call)
  if (dim(x$tbl)[1] !=1)   
      xx <- x$tbl[,c("BIC","RIC","AIC","GCV","DROP","DF")]
  else xx <- x$tbl[1,c("BIC","RIC","AIC","GCV","DROP","DF")]
  dimnames(xx)[[1]] <- as.character(x$tbl[,"NP"])
  cat("\n\nFitting Table :\n")
  print(xx)
  start.loc <- eval(x$call$start$puloc, sys.parent())
  cat("\nInitial location(s):")
  cat(paste(round(start.loc, 3)), "\n")
  cat("\nLocation(s) selected:\n")

  k.AIC <- min(x$tbl[x$tbl[, "AIC"] == min( x$tbl[, "AIC"] ), "NP"])
  AIC.drop <- x$tbl[x$tbl[, "NP"] > k.AIC, "DROP"]	# print simle info
  crt.msg <- if(is.null(x$call$weight)) "with AIC," else	"with weighted AIC,"
  cat(paste(crt.msg), "\n")
  cat(paste(k.AIC), "pulse(s) :")
  if(length(AIC.drop) > 0)
     cat(paste(round(start.loc[-AIC.drop],3)),"\n")
  else
     cat(paste(round(start.loc,3)),"\n")

  k.GCV <- min(x$tbl[x$tbl[, "GCV"] == min( x$tbl[, "GCV"] ), "NP"])
  GCV.drop <- x$tbl[x$tbl[, "NP"] > k.GCV, "DROP"]	# print simle info
  crt.msg <- if(is.null(x$call$weight)) "with GCV," else	"with weighted GCV,"
  cat(paste(crt.msg), "\n")
  cat(paste(k.GCV), "pulse(s) :")
  if(length(GCV.drop) > 0)
     cat(paste(round(start.loc[-GCV.drop],3)),"\n")
  else
     cat(paste(round(start.loc,3)),"\n")

  k.BIC <- min(x$tbl[x$tbl[, "BIC"] == min( x$tbl[, "BIC"] ), "NP"])
  BIC.drop <- x$tbl[x$tbl[, "NP"] > k.BIC, "DROP"]	# print simle info
  crt.msg <- if(is.null(x$call$weight)) "with BIC," else	"with weighted BIC,"
  cat(paste(crt.msg), "\n")
  cat(paste(k.BIC), "pulse(s) :")
  if(length(BIC.drop) > 0)
     cat(paste(round(start.loc[-BIC.drop],3)),"\n")
  else
     cat(paste(round(start.loc,3)),"\n")

  k.RIC <- min(x$tbl[x$tbl[, "RIC"] == min( x$tbl[, "RIC"] ), "NP"])
  RIC.drop <- x$tbl[x$tbl[, "NP"] > k.RIC, "DROP"]	# print simle info
  crt.msg <- if(is.null(x$call$weight)) "with RIC," else	"with weighted RIC,"
  cat(paste(crt.msg), "\n")
  cat(paste(k.RIC), "pulse(s) :")
  if(length(RIC.drop) > 0)
     cat(paste(round(start.loc[-RIC.drop],3)),"\n")
  else
     cat(paste(round(start.loc,3)),"\n")
  invisible()
}


"summary.puldet"  <- function(x)
{
  cat("Identification for Hormone Pulses\n")
  cat("Call:\n")
  dput(x$call)
  cat("\n\nFitting Tables :\n")
  print(x$tbl)
  start.loc <- eval(x$call$start$puloc, sys.parent())
  cat("\nInitial location(s):")
  cat(paste(round(start.loc, 3)), "\n")
  cat("\nLocation(s) selected:\n")

  k.AIC <- min(x$tbl[x$tbl[, "AIC"] == min( x$tbl[, "AIC"] ), "NP"])
  AIC.drop <- x$tbl[x$tbl[, "NP"] > k.AIC, "DROP"]	# print simle info
  crt.msg <- if(is.null(x$call$weight)) "with AIC," else	"with weighted AIC,"
  cat(paste(crt.msg), "\n")
  cat(paste(k.AIC), "pulse(s) :")
   if(length(AIC.drop) > 0)
     AIC.loc <- start.loc[-AIC.drop]
  else
     AIC.loc <- start.loc
  cat(paste(round(AIC.loc, 3)), "\n")


  k.GCV <- min(x$tbl[x$tbl[, "GCV"] == min( x$tbl[, "GCV"] ), "NP"])
  GCV.drop <- x$tbl[x$tbl[, "NP"] > k.GCV, "DROP"]	# print simle info
  crt.msg <- if(is.null(x$call$weight)) "with GCV," else	"with weighted GCV,"
  cat(paste(crt.msg), "\n")
  cat(paste(k.GCV), "pulse(s) :")
    if(length(AIC.drop) > 0)
     GCV.loc <- start.loc[-GCV.drop]
  else
     GCV.loc <- start.loc
  cat(paste(round(GCV.loc, 3)), "\n")

  k.BIC <- min(x$tbl[x$tbl[, "BIC"] == min( x$tbl[, "BIC"] ), "NP"])
  BIC.drop <- x$tbl[x$tbl[, "NP"] > k.BIC, "DROP"]	# print simle info
  crt.msg <- if(is.null(x$call$weight)) "with BIC," else	"with weighted BIC,"
  cat(paste(crt.msg), "\n")
  cat(paste(k.BIC), "pulse(s) :")
  if(length(BIC.drop) > 0)
     BIC.loc <- start.loc[-BIC.drop]
  else
     BIC.loc <- start.loc
  cat(paste(round(BIC.loc, 3)), "\n")

  k.RIC <- min(x$tbl[x$tbl[, "RIC"] == min( x$tbl[, "RIC"] ), "NP"])
  RIC.drop <- x$tbl[x$tbl[, "NP"] > k.RIC, "DROP"]	# print simle info
  crt.msg <- if(is.null(x$call$weight)) "with RIC," else	"with weighted RIC,"
  cat(paste(crt.msg), "\n")
  cat(paste(k.RIC), "pulse(s) :")
   if(length(RIC.drop) > 0)
     RIC.loc <- start.loc[-RIC.drop]
  else
     RIC.loc <- start.loc
  cat(paste(round(RIC.loc, 3)), "\n")

   fBIC.est <- x$est[[k.BIC]]$baseFitted
   nlmeBIC.est <- x$est[[k.BIC]]$nlmeFitted
   coef.BIC <- x$est[[k.BIC]]$coef

   fRIC.est <- x$est[[k.RIC]]$baseFitted
   nlmeRIC.est <- x$est[[k.RIC]]$nlmeFitted
   coef.RIC <- x$est[[k.RIC]]$coef

 fAIC.est <- x$est[[k.AIC]]$baseFitted
   nlmeAIC.est <- x$est[[k.AIC]]$nlmeFitted
   coef.AIC <- x$est[[k.AIC]]$coef

 fGCV.est <- x$est[[k.GCV]]$baseFitted
   nlmeGCV.est <- x$est[[k.GCV]]$nlmeFitted
   coef.GCV <- x$est[[k.GCV]]$coef

invisible()
}



"pul.control" <- function(maxIter= 100, pnlsMaxIter=5, msMaxIter=10, tolerance=10e-3,
                    pnlsTol=10e-3, msTol=10e-3, gradHess=TRUE, apVar=TRUE,returnObject=TRUE,
                    msVerbose=FALSE, spar="v", TOLr=10e-3, nlsMaxIter=5, minScale=0.01, nlsTol=0.01, limnla=c(-3,1), IDF=1.2, trace=FALSE)  {
  list( nlme = list(maxIter = maxIter, pnlsMaxIter = pnlsMaxIter, msMaxIter = msMaxIter,
          tolerance = tolerance, pnlsTol = pnlsTol, msTol = msTol, gradHess = gradHess,
          apVar = apVar,returnObject = returnObject, msVerbose = msVerbose),
       ssr = list(spar = spar, limnla=limnla), pul = list(TOLr = TOLr, IDF=IDF, trace=trace), gnls= list(maxIter=maxIter, nlsMaxIter=nlsMaxIter, msMaxIter=msMaxIter, minScale=minScale, tolerance=tolerance, nlsTol=nlsTol, msTol=msTol)
)
}
